@echo off

echo Generating help (20-30 seconds) ...

rem Export help

rem You may use sqlcmd.exe, dbsetup.exe (embedded), or gsqlcmd.exe

rem https://www.microsoft.com/en-us/download/details.aspx?id=53591
rem https://docs.microsoft.com/en-us/sql/tools/sqlcmd-utility?view=sql-server-2017

rem sqlcmd.exe -S .\SQLEXPRESS -d gPlanningApp -U pa_developer_01 -P Usr_2011#_Xls4168 -y0 -Q "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 1" -f 65001 -o source.htm
rem sqlcmd.exe -S .\SQLEXPRESS -d gPlanningApp -U pa_developer_01 -P Usr_2011#_Xls4168 -y0 -Q "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 2" -f 65001 -o source-tables.htm
rem sqlcmd.exe -S .\SQLEXPRESS -d gPlanningApp -U pa_developer_01 -P Usr_2011#_Xls4168 -y0 -Q "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 3" -f 65001 -o source-views.htm
rem sqlcmd.exe -S .\SQLEXPRESS -d gPlanningApp -U pa_developer_01 -P Usr_2011#_Xls4168 -y0 -Q "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 4" -f 65001 -o source-procedures.htm
rem sqlcmd.exe -S .\SQLEXPRESS -d gPlanningApp -U pa_developer_01 -P Usr_2011#_Xls4168 -y0 -Q "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 5" -f 65001 -o source-functions.htm

rem The connection string 'help' defined in gsqlcmd.exe.config

dbsetup.exe help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 1" /Y -o source.htm
dbsetup.exe help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 2" /Y -o source-tables.htm
dbsetup.exe help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 3" /Y -o source-views.htm
dbsetup.exe help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 4" /Y -o source-procedures.htm
dbsetup.exe help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 5" /Y -o source-functions.htm

rem https://www.gsqlcmd.com

rem gsqlcmd.exe exec help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 1" source.htm            /astxt /noheaders /outputcodepage=65001
rem gsqlcmd.exe exec help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 2" source-tables.htm     /astxt /noheaders /outputcodepage=65001
rem gsqlcmd.exe exec help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 3" source-views.htm      /astxt /noheaders /outputcodepage=65001
rem gsqlcmd.exe exec help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 4" source-procedures.htm /astxt /noheaders /outputcodepage=65001
rem gsqlcmd.exe exec help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 5" source-functions.htm  /astxt /noheaders /outputcodepage=65001


if errorlevel 1 (
    if exist source.htm type source.htm
    if exist source.htm del source.htm
    goto END
)

if not exist source.htm goto END


rem Update help using regular expressions
rem https://docs.microsoft.com/en-us/dotnet/standard/base-types/regular-expression-language-quick-reference

rem You may use grx.exe or powershell.exe


grx.exe make-help.mak source.htm            help.htm
grx.exe make-help.mak source-tables.htm     help-tables.htm
grx.exe make-help.mak source-views.htm      help-views.htm
grx.exe make-help.mak source-procedures.htm help-procedures.htm
grx.exe make-help.mak source-functions.htm  help-functions.htm


grx.exe "'https://www.savetodb.com/help/planning-application.htm#','#'"             help.htm            help.htm
grx.exe "'https://www.savetodb.com/help/planning-application-tables.htm#','#'"      help-tables.htm     help-tables.htm
grx.exe "'https://www.savetodb.com/help/planning-application-views.htm#','#'"       help-views.htm      help-views.htm
grx.exe "'https://www.savetodb.com/help/planning-application-procedures.htm#','#'"  help-procedures.htm help-procedures.htm
grx.exe "'https://www.savetodb.com/help/planning-application-functions.htm#','#'"   help-functions.htm  help-functions.htm


rem To use this feature, run the PowerShell and set the execution policy to the Unrestricted:
rem Set-ExecutionPolicy -Scope CurrentUser -ExecutionPolicy Unrestricted
rem
rem See details:
rem https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.security/set-executionpolicy


rem powershell.exe -file make-help.ps1 source.htm            help.htm
rem powershell.exe -file make-help.ps1 source-tables.htm     help-tables.htm
rem powershell.exe -file make-help.ps1 source-views.htm      help-views.htm
rem powershell.exe -file make-help.ps1 source-procedures.htm help-procedures.htm
rem powershell.exe -file make-help.ps1 source-functions.htm  help-functions.htm

rem powershell.exe -command "(Get-Content help.htm            -encoding UTF8 -Raw) | Foreach-Object {$_ -replace 'https://www.savetodb.com/help/planning-application.htm#', '#'}            | Set-Content -Encoding UTF8 help.htm"
rem powershell.exe -command "(Get-Content help-tables.htm     -encoding UTF8 -Raw) | Foreach-Object {$_ -replace 'https://www.savetodb.com/help/planning-application-tables.htm#', '#'}     | Set-Content -Encoding UTF8 help-tables.htm"
rem powershell.exe -command "(Get-Content help-views.htm      -encoding UTF8 -Raw) | Foreach-Object {$_ -replace 'https://www.savetodb.com/help/planning-application-views.htm#', '#'}      | Set-Content -Encoding UTF8 help-views.htm"
rem powershell.exe -command "(Get-Content help-procedures.htm -encoding UTF8 -Raw) | Foreach-Object {$_ -replace 'https://www.savetodb.com/help/planning-application-procedures.htm#', '#'} | Set-Content -Encoding UTF8 help-procedures.htm"
rem powershell.exe -command "(Get-Content help-functions.htm  -encoding UTF8 -Raw) | Foreach-Object {$_ -replace 'https://www.savetodb.com/help/planning-application-functions.htm#', '#'}  | Set-Content -Encoding UTF8 help-functions.htm"


echo Open help.htm

:END

pause
